<?php
/**
 * THIS IS AN AUTOGENERATED FILE
 * DO NOT MODIFY
 * @codingStandardsIgnoreFile
 */


namespace Ls\Replication\Setup\UpgradeSchema;

use Magento\Framework\Setup\SchemaSetupInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\DB\Ddl\Table;

class LoyItem
{

    public function upgrade(SchemaSetupInterface $setup, ModuleContextInterface $context)
    {
        $table_name = $setup->getTable( 'ls_replication_loy_item' ); 
        if(!$setup->tableExists($table_name)) {
        	$table = $setup->getConnection()->newTable( $table_name );
        	$table->addColumn('loy_item_id', Table::TYPE_INTEGER, 11, [ 'identity' => TRUE, 'primary' => TRUE, 'unsigned' => TRUE, 'nullable' => FALSE, 'auto_increment'=> TRUE ]);
        	$table->addColumn('AllowedToSell' , Table::TYPE_BOOLEAN, 1);
        	$table->addColumn('BlockDiscount' , Table::TYPE_BOOLEAN, 1);
        	$table->addColumn('BlockManualPriceChange' , Table::TYPE_BOOLEAN, 1);
        	$table->addColumn('Blocked' , Table::TYPE_BOOLEAN, 1);
        	$table->addColumn('Description' , Table::TYPE_TEXT, '');
        	$table->addColumn('Details' , Table::TYPE_TEXT, '');
        	$table->addColumn('GrossWeight' , Table::TYPE_DECIMAL, '20,4');
        	$table->addColumn('IsDeleted' , Table::TYPE_BOOLEAN, 1);
        	$table->addColumn('ItemCategoryCode' , Table::TYPE_TEXT, '');
        	$table->addColumn('ItemFamilyCode' , Table::TYPE_TEXT, '');
        	$table->addColumn('Price' , Table::TYPE_TEXT, '');
        	$table->addColumn('ProductGroupId' , Table::TYPE_TEXT, '');
        	$table->addColumn('SalesUomId' , Table::TYPE_TEXT, '');
        	$table->addColumn('ScaleItem' , Table::TYPE_BOOLEAN, 1);
        	$table->addColumn('SeasonCode' , Table::TYPE_TEXT, '');
        	$table->addColumn('UnitVolume' , Table::TYPE_DECIMAL, '20,4');
        	$table->addColumn('UnitsPerParcel' , Table::TYPE_DECIMAL, '20,4');
        	$table->addColumn('nav_id' , Table::TYPE_TEXT, '');
        	$table->addColumn('processed', Table::TYPE_BOOLEAN, 1, [ 'default' => 0 ], 'Flag to check if data is already copied into Magento. 0 means needs to be copied into Magento tables & 1 means already copied');
        	$table->addColumn('is_updated', Table::TYPE_BOOLEAN, 1, [ 'default' => 0 ], 'Flag to check if data is already updated from Omni into Magento. 0 means already updated & 1 means needs to be updated into Magento tables');
        	$table->addColumn('is_failed', Table::TYPE_BOOLEAN, 1, [ 'default' => 0 ], 'Flag to check if data is already added from Flat into Magento successfully or not. 0 means already added successfully & 1 means failed to add successfully into Magento tables');
        	$table->addColumn('checksum', Table::TYPE_TEXT,'');
        	$table->addColumn('processed_at', Table::TYPE_TIMESTAMP, null, [ 'nullable' => true ], 'Processed At');
        	$table->addColumn('created_at', Table::TYPE_TIMESTAMP, null, [ 'nullable' => false, 'default' => Table::TIMESTAMP_INIT ], 'Created At');
        	$table->addColumn('updated_at', Table::TYPE_TIMESTAMP, null, [ 'nullable' => false, 'default' => Table::TIMESTAMP_INIT_UPDATE ], 'Updated At');
        	$setup->getConnection()->createTable( $table );
        } else {
        	$connection = $setup->getConnection();
        	if ($connection->tableColumnExists($table_name, 'AllowedToSell' ) === false) {
        		$connection->addColumn($table_name, 'AllowedToSell', ['length' => 1,'default' => 0,'type' => Table::TYPE_BOOLEAN, 'comment' => 'AllowedToSell']);
        	} else {
        		$connection->modifyColumn($table_name, 'AllowedToSell', ['length' => 1,'default' => 0,'type' => Table::TYPE_BOOLEAN, 'comment' => 'AllowedToSell']);
        	}
        	if ($connection->tableColumnExists($table_name, 'BlockDiscount' ) === false) {
        		$connection->addColumn($table_name, 'BlockDiscount', ['length' => 1,'default' => 0,'type' => Table::TYPE_BOOLEAN, 'comment' => 'BlockDiscount']);
        	} else {
        		$connection->modifyColumn($table_name, 'BlockDiscount', ['length' => 1,'default' => 0,'type' => Table::TYPE_BOOLEAN, 'comment' => 'BlockDiscount']);
        	}
        	if ($connection->tableColumnExists($table_name, 'BlockManualPriceChange' ) === false) {
        		$connection->addColumn($table_name, 'BlockManualPriceChange', ['length' => 1,'default' => 0,'type' => Table::TYPE_BOOLEAN, 'comment' => 'BlockManualPriceChange']);
        	} else {
        		$connection->modifyColumn($table_name, 'BlockManualPriceChange', ['length' => 1,'default' => 0,'type' => Table::TYPE_BOOLEAN, 'comment' => 'BlockManualPriceChange']);
        	}
        	if ($connection->tableColumnExists($table_name, 'Blocked' ) === false) {
        		$connection->addColumn($table_name, 'Blocked', ['length' => 1,'default' => 0,'type' => Table::TYPE_BOOLEAN, 'comment' => 'Blocked']);
        	} else {
        		$connection->modifyColumn($table_name, 'Blocked', ['length' => 1,'default' => 0,'type' => Table::TYPE_BOOLEAN, 'comment' => 'Blocked']);
        	}
        	if ($connection->tableColumnExists($table_name, 'Description' ) === false) {
        		$connection->addColumn($table_name, 'Description', ['length' => '','default' => null,'type' => Table::TYPE_TEXT, 'comment' => 'Description']);
        	} else {
        		$connection->modifyColumn($table_name, 'Description', ['length' => '','default' => null,'type' => Table::TYPE_TEXT, 'comment' => 'Description']);
        	}
        	if ($connection->tableColumnExists($table_name, 'Details' ) === false) {
        		$connection->addColumn($table_name, 'Details', ['length' => '','default' => null,'type' => Table::TYPE_TEXT, 'comment' => 'Details']);
        	} else {
        		$connection->modifyColumn($table_name, 'Details', ['length' => '','default' => null,'type' => Table::TYPE_TEXT, 'comment' => 'Details']);
        	}
        	if ($connection->tableColumnExists($table_name, 'GrossWeight' ) === false) {
        		$connection->addColumn($table_name, 'GrossWeight', ['length' => '20,4','default' => null,'type' => Table::TYPE_DECIMAL, 'comment' => 'GrossWeight']);
        	} else {
        		$connection->modifyColumn($table_name, 'GrossWeight', ['length' => '20,4','default' => null,'type' => Table::TYPE_DECIMAL, 'comment' => 'GrossWeight']);
        	}
        	if ($connection->tableColumnExists($table_name, 'IsDeleted' ) === false) {
        		$connection->addColumn($table_name, 'IsDeleted', ['length' => 1,'default' => 0,'type' => Table::TYPE_BOOLEAN, 'comment' => 'IsDeleted']);
        	} else {
        		$connection->modifyColumn($table_name, 'IsDeleted', ['length' => 1,'default' => 0,'type' => Table::TYPE_BOOLEAN, 'comment' => 'IsDeleted']);
        	}
        	if ($connection->tableColumnExists($table_name, 'ItemCategoryCode' ) === false) {
        		$connection->addColumn($table_name, 'ItemCategoryCode', ['length' => '','default' => null,'type' => Table::TYPE_TEXT, 'comment' => 'ItemCategoryCode']);
        	} else {
        		$connection->modifyColumn($table_name, 'ItemCategoryCode', ['length' => '','default' => null,'type' => Table::TYPE_TEXT, 'comment' => 'ItemCategoryCode']);
        	}
        	if ($connection->tableColumnExists($table_name, 'ItemFamilyCode' ) === false) {
        		$connection->addColumn($table_name, 'ItemFamilyCode', ['length' => '','default' => null,'type' => Table::TYPE_TEXT, 'comment' => 'ItemFamilyCode']);
        	} else {
        		$connection->modifyColumn($table_name, 'ItemFamilyCode', ['length' => '','default' => null,'type' => Table::TYPE_TEXT, 'comment' => 'ItemFamilyCode']);
        	}
        	if ($connection->tableColumnExists($table_name, 'Price' ) === false) {
        		$connection->addColumn($table_name, 'Price', ['length' => '','default' => null,'type' => Table::TYPE_TEXT, 'comment' => 'Price']);
        	} else {
        		$connection->modifyColumn($table_name, 'Price', ['length' => '','default' => null,'type' => Table::TYPE_TEXT, 'comment' => 'Price']);
        	}
        	if ($connection->tableColumnExists($table_name, 'ProductGroupId' ) === false) {
        		$connection->addColumn($table_name, 'ProductGroupId', ['length' => '','default' => null,'type' => Table::TYPE_TEXT, 'comment' => 'ProductGroupId']);
        	} else {
        		$connection->modifyColumn($table_name, 'ProductGroupId', ['length' => '','default' => null,'type' => Table::TYPE_TEXT, 'comment' => 'ProductGroupId']);
        	}
        	if ($connection->tableColumnExists($table_name, 'SalesUomId' ) === false) {
        		$connection->addColumn($table_name, 'SalesUomId', ['length' => '','default' => null,'type' => Table::TYPE_TEXT, 'comment' => 'SalesUomId']);
        	} else {
        		$connection->modifyColumn($table_name, 'SalesUomId', ['length' => '','default' => null,'type' => Table::TYPE_TEXT, 'comment' => 'SalesUomId']);
        	}
        	if ($connection->tableColumnExists($table_name, 'ScaleItem' ) === false) {
        		$connection->addColumn($table_name, 'ScaleItem', ['length' => 1,'default' => 0,'type' => Table::TYPE_BOOLEAN, 'comment' => 'ScaleItem']);
        	} else {
        		$connection->modifyColumn($table_name, 'ScaleItem', ['length' => 1,'default' => 0,'type' => Table::TYPE_BOOLEAN, 'comment' => 'ScaleItem']);
        	}
        	if ($connection->tableColumnExists($table_name, 'SeasonCode' ) === false) {
        		$connection->addColumn($table_name, 'SeasonCode', ['length' => '','default' => null,'type' => Table::TYPE_TEXT, 'comment' => 'SeasonCode']);
        	} else {
        		$connection->modifyColumn($table_name, 'SeasonCode', ['length' => '','default' => null,'type' => Table::TYPE_TEXT, 'comment' => 'SeasonCode']);
        	}
        	if ($connection->tableColumnExists($table_name, 'UnitVolume' ) === false) {
        		$connection->addColumn($table_name, 'UnitVolume', ['length' => '20,4','default' => null,'type' => Table::TYPE_DECIMAL, 'comment' => 'UnitVolume']);
        	} else {
        		$connection->modifyColumn($table_name, 'UnitVolume', ['length' => '20,4','default' => null,'type' => Table::TYPE_DECIMAL, 'comment' => 'UnitVolume']);
        	}
        	if ($connection->tableColumnExists($table_name, 'UnitsPerParcel' ) === false) {
        		$connection->addColumn($table_name, 'UnitsPerParcel', ['length' => '20,4','default' => null,'type' => Table::TYPE_DECIMAL, 'comment' => 'UnitsPerParcel']);
        	} else {
        		$connection->modifyColumn($table_name, 'UnitsPerParcel', ['length' => '20,4','default' => null,'type' => Table::TYPE_DECIMAL, 'comment' => 'UnitsPerParcel']);
        	}
        	if ($connection->tableColumnExists($table_name, 'nav_id' ) === false) {
        		$connection->addColumn($table_name, 'nav_id', ['length' => '','default' => null,'type' => Table::TYPE_TEXT, 'comment' => 'Nav_id']);
        	} else {
        		$connection->modifyColumn($table_name, 'nav_id', ['length' => '','default' => null,'type' => Table::TYPE_TEXT, 'comment' => 'Nav_id']);
        	}
        	if ($connection->tableColumnExists($table_name, 'processed' ) === false) {
        		$connection->addColumn($table_name, 'processed', ['length' => 1,'default' => 0,'type' => Table::TYPE_BOOLEAN, 'comment' => 'Flag to check if data is already copied into Magento. 0 means needs to be copied into Magento tables & 1 means already copied']);
        	} else {
        		$connection->modifyColumn($table_name, 'processed', ['length' => 1,'default' => 0,'type' => Table::TYPE_BOOLEAN, 'comment' => 'Flag to check if data is already copied into Magento. 0 means needs to be copied into Magento tables & 1 means already copied']);
        	}
        	if ($connection->tableColumnExists($table_name, 'is_updated' ) === false) {
        		$connection->addColumn($table_name, 'is_updated', ['length' => 1,'default' => 0,'type' => Table::TYPE_BOOLEAN, 'comment' => 'Flag to check if data is already updated from Omni into Magento. 0 means already updated & 1 means needs to be updated into Magento tables']);
        	} else {
        		$connection->modifyColumn($table_name, 'is_updated', ['length' => 1,'default' => 0,'type' => Table::TYPE_BOOLEAN, 'comment' => 'Flag to check if data is already updated from Omni into Magento. 0 means already updated & 1 means needs to be updated into Magento tables']);
        	}
        	if ($connection->tableColumnExists($table_name, 'is_failed' ) === false) {
        		$connection->addColumn($table_name, 'is_failed', ['length' => 1,'default' => 0,'type' => Table::TYPE_BOOLEAN, 'comment' => 'Flag to check if data is already added from Flat into Magento successfully or not. 0 means already added successfully & 1 means failed to add successfully into Magento tables']);
        	} else {
        		$connection->modifyColumn($table_name, 'is_failed', ['length' => 1,'default' => 0,'type' => Table::TYPE_BOOLEAN, 'comment' => 'Flag to check if data is already added from Flat into Magento successfully or not. 0 means already added successfully & 1 means failed to add successfully into Magento tables']);
        	}
        	if ($connection->tableColumnExists($table_name, 'checksum' ) === false) {
        		$connection->addColumn($table_name, 'checksum', ['length' => '','default' => null,'type' => Table::TYPE_TEXT, 'comment' => 'Checksum']);
        	} else {
        		$connection->modifyColumn($table_name, 'checksum', ['length' => '','default' => null,'type' => Table::TYPE_TEXT, 'comment' => 'Checksum']);
        	}
        	if ($connection->tableColumnExists($table_name, 'processed_at' ) === false) {
        		$connection->addColumn($table_name, 'processed_at', ['length' => '','default' => null,'type' => Table::TYPE_TIMESTAMP, 'comment' => 'Processed At']);
        	} else {
        		$connection->modifyColumn($table_name, 'processed_at', ['length' => '','default' => null,'type' => Table::TYPE_TIMESTAMP, 'comment' => 'Processed At']);
        	}
        	if ($connection->tableColumnExists($table_name, 'created_at' ) === false) {
        		$connection->addColumn($table_name, 'created_at', ['length' => '','default' => Table::TIMESTAMP_INIT,'type' => Table::TYPE_TIMESTAMP, 'comment' => 'Created At']);
        	} else {
        		$connection->modifyColumn($table_name, 'created_at', ['length' => '','default' => Table::TIMESTAMP_INIT,'type' => Table::TYPE_TIMESTAMP, 'comment' => 'Created At']);
        	}
        	if ($connection->tableColumnExists($table_name, 'updated_at' ) === false) {
        		$connection->addColumn($table_name, 'updated_at', ['length' => '','default' => Table::TIMESTAMP_INIT_UPDATE,'type' => Table::TYPE_TIMESTAMP, 'comment' => 'Updated At']);
        	} else {
        		$connection->modifyColumn($table_name, 'updated_at', ['length' => '','default' => Table::TIMESTAMP_INIT_UPDATE,'type' => Table::TYPE_TIMESTAMP, 'comment' => 'Updated At']);
        	}
        }
    }


}

